package cn.cecep.talroad.controller;

import cn.cecep.talroad.common.core.exception.CommonException;
import cn.cecep.talroad.common.core.utils.poi.ExcelUtil;
import cn.cecep.talroad.common.core.web.controller.BasesController;
import cn.cecep.talroad.common.core.web.domain.AjaxResults;
import cn.cecep.talroad.common.log.annotation.Log;
import cn.cecep.talroad.common.log.enums.BusinessType;
import cn.cecep.talroad.common.security.annotation.RequiresPermissions;
import cn.cecep.talroad.domain.BEnterpriseIrEes;
import cn.cecep.talroad.service.IBEnterpriseIrEesService;
import cn.cecep.talroad.vo.BEnterpriseIrEesVo;
import cn.cecep.talroad.vo.query.BEnterpriseIrEesQuery;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.security.InvalidParameterException;
import java.util.Arrays;
import java.util.List;


/**
 * * 开发公司：中节能天融科技有限公司
 * 知识库-生态环境标准Controller 控制层
 *
 * @author szhpt
 * @date 2023-03-14*/
@Api(tags = "知识库-生态环境标准")
@RestController
@RequestMapping("/ees")
public class BEnterpriseIrEesController extends BasesController
{
    @Autowired
    private IBEnterpriseIrEesService bEnterpriseIrEesService;

    /**
     * 查询知识库-生态环境标准列表
     */
    @ApiOperation(value = "查询知识库-生态环境标准")
    @GetMapping("/list")
    public AjaxResults<IPage<BEnterpriseIrEes>> list(BEnterpriseIrEesQuery bEnterpriseIrEes)
    {
        Page<BEnterpriseIrEes> page = new Page<>(bEnterpriseIrEes.getPageNum(), bEnterpriseIrEes.getPageSize());
        IPage<BEnterpriseIrEes> list = bEnterpriseIrEesService.page(page, BEnterpriseIrEesQuery.createLambdaQueryWrapper(bEnterpriseIrEes));
        return AjaxResults.success(list);
    }


    /**
     * 导出知识库-生态环境标准列表
     */
    @ApiOperation(value = "导出知识库-生态环境标准")
    @Log(title = "知识库-生态环境标准", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, BEnterpriseIrEes bEnterpriseIrEes)
    {
        List<BEnterpriseIrEes> list = bEnterpriseIrEesService.selectBEnterpriseIrEesList(bEnterpriseIrEes);
        ExcelUtil<BEnterpriseIrEes> util = new ExcelUtil<BEnterpriseIrEes>(BEnterpriseIrEes.class);
        util.exportExcel(response, list, "知识库-生态环境标准数据");
    }

    /**
     * 获取知识库-生态环境标准详细信息
     */
    @ApiOperation(value = "获取知识库-生态环境标准详细信息")
    @PostMapping(value = "/{id}")
    public AjaxResults<BEnterpriseIrEes> getInfo(@PathVariable("id") Integer id) {
        return AjaxResults.success(bEnterpriseIrEesService.getById(id));
    }
    /**
     * 新增知识库-生态环境标准
     */
    @ApiOperation(value = "新增知识库-生态环境标准")
    @Log(title = "知识库-生态环境标准", businessType = BusinessType.INSERT)
    @PostMapping(value = "/add")
    public AjaxResults<Boolean> add(@RequestBody BEnterpriseIrEes bEnterpriseIrEes) {
        return toAjax(bEnterpriseIrEesService.save(bEnterpriseIrEes));
    }
    /**
     * 修改知识库-生态环境标准
     */
    @ApiOperation(value = "修改知识库-生态环境标准")
    @Log(title = "知识库-生态环境标准", businessType = BusinessType.UPDATE)
    @PostMapping(value = "/edit")
    public AjaxResults<Boolean> edit(@RequestBody BEnterpriseIrEesVo bEnterpriseIrEesVo) {
        if(ObjectUtil.isEmpty(bEnterpriseIrEesVo)){
            throw new InvalidParameterException("参数为空");
        }
        if(ObjectUtil.isEmpty(bEnterpriseIrEesVo.getId())){
            throw new InvalidParameterException("参数id为空");
        }
        BEnterpriseIrEes bEnterpriseIrEes = bEnterpriseIrEesService.getById(bEnterpriseIrEesVo.getId());
        if(ObjectUtil.isEmpty(bEnterpriseIrEes)){
            throw new CommonException(StrUtil.format("根据id{}查询不到数据", bEnterpriseIrEesVo.getId()));
        }
        //赋值
        BeanUtil.copyProperties(bEnterpriseIrEesVo,bEnterpriseIrEes);
        return toAjax(bEnterpriseIrEesService.saveOrUpdate(bEnterpriseIrEes));
    }

    /**
     * 删除知识库-生态环境标准
     */
    @ApiOperation(value = "删除知识库-生态环境标准")
    @RequiresPermissions("talroad:ees:remove")
    @Log(title = "知识库-生态环境标准", businessType = BusinessType.DELETE)
    @PostMapping("/{ids}")
    public AjaxResults<Boolean> remove(@PathVariable String[] ids) {
        return toAjax(bEnterpriseIrEesService.removeByIds(Arrays.asList(ids)));
    }
}
